commit 6bd1416fab987d9cb4c11bd47bbe8bc933570bd2
Author: Athina Bekakou <athinabek@grnet.gr>
Date:   Mon Sep 30 14:51:58 2013 +0300

    new ui: add functionality to network creation wizard

diff --git a/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css b/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css
index f84df6e..050dd61 100644
--- a/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css
+++ b/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css
@@ -7074,6 +7074,12 @@ body {
   overflow: hidden;
 }
 
+/* line 236, ../sass/_common.scss */
+.main {
+  padding: 0 40px;
+  overflow: hidden;
+}
+
 /* Header ----------------------------------------------- */
 /* line 245, ../sass/_common.scss */
 .header {
@@ -7862,48 +7868,53 @@ body {
 #network-wizard li {
   list-style: none outside none;
 }
-/* line 35, ../sass/_networks.scss */
+/* line 36, ../sass/_networks.scss */
+#network-wizard .net_wiz_main {
+  padding: 40px;
+  width: 390px;
+}
+/* line 42, ../sass/_networks.scss */
 #network-wizard .snf-checkbox-checked, #network-wizard .snf-checkbox-unchecked {
   font-size: 1.3em;
 }
-/* line 38, ../sass/_networks.scss */
+/* line 45, ../sass/_networks.scss */
 #network-wizard .subnet_options {
   margin: 0;
 }
-/* line 40, ../sass/_networks.scss */
+/* line 47, ../sass/_networks.scss */
 #network-wizard .subnet_options li {
   margin-bottom: 6px;
   padding-left: 155px;
 }
-/* line 48, ../sass/_networks.scss */
+/* line 55, ../sass/_networks.scss */
 #network-wizard .main {
   padding: 40px;
 }
-/* line 51, ../sass/_networks.scss */
+/* line 58, ../sass/_networks.scss */
 #network-wizard .main a {
   color: white;
 }
-/* line 52, ../sass/_networks.scss */
+/* line 59, ../sass/_networks.scss */
 #network-wizard .main .network_options {
   position: relative;
   width: 350px;
   min-height: 285px;
 }
-/* line 57, ../sass/_networks.scss */
-#network-wizard .main .network_options .check {
+/* line 64, ../sass/_networks.scss */
+#network-wizard .main .network_options .check, #network-wizard .main .network_options .radio_btn {
   position: absolute;
   right: 0;
 }
-/* line 62, ../sass/_networks.scss */
+/* line 70, ../sass/_networks.scss */
 #network-wizard .main .network_options li {
   display: block;
   margin-bottom: 13px;
 }
-/* line 66, ../sass/_networks.scss */
+/* line 74, ../sass/_networks.scss */
 #network-wizard .main .network_options li form {
   margin: 0;
 }
-/* line 69, ../sass/_networks.scss */
+/* line 77, ../sass/_networks.scss */
 #network-wizard .main .network_options li form input {
   position: absolute;
   display: inline-block;
@@ -7912,16 +7923,16 @@ body {
   height: 20px;
   font-size: 0.9em;
 }
-/* line 77, ../sass/_networks.scss */
+/* line 85, ../sass/_networks.scss */
 #network-wizard .main .network_options li form input.hidden {
   display: none;
 }
-/* line 82, ../sass/_networks.scss */
+/* line 90, ../sass/_networks.scss */
 #network-wizard .main .network_options li.manual form input {
   right: -160px;
   width: 150px;
 }
-/* line 87, ../sass/_networks.scss */
+/* line 95, ../sass/_networks.scss */
 #network-wizard .main .network_options span.sub_title {
   float: left;
 }
@@ -8717,13 +8728,7 @@ Overlays (Todo: clean up)
 .wizard .middle .step .advanced-conf-step .advanced-conf-options .tags-area .btn5, .wizard .middle .step .advanced-conf-step .advanced-conf-options .tags-area .os li .btn-col a, .wizard .middle .step .os li .btn-col .advanced-conf-step .advanced-conf-options .tags-area a, .wizard .middle .step .advanced-conf-step .advanced-conf-options .tags-area .flavor li .options-bar .options li a, .wizard .middle .step .flavor li .options-bar .options li .advanced-conf-step .advanced-conf-options .tags-area a {
   margin-right: 20px;
 }
-/* line 531, ../sass/_overlays.scss */
-.wizard .middle .main .network_options input {
-  width: 250px;
-  display: inline-block;
-  margin-left: 25px;
-}
-/* line 539, ../sass/_overlays.scss */
+/* line 530, ../sass/_overlays.scss */
 .wizard .bottom {
   position: fixed;
   left: 0;
@@ -8732,12 +8737,12 @@ Overlays (Todo: clean up)
   border-top: 1px solid #333333;
   background: #485057;
 }
-/* line 546, ../sass/_overlays.scss */
+/* line 537, ../sass/_overlays.scss */
 .wizard .bottom .row {
   height: 60px;
   line-height: 60px;
 }
-/* line 550, ../sass/_overlays.scss */
+/* line 541, ../sass/_overlays.scss */
 .wizard .bottom .nav {
   height: 60px;
   line-height: 60px;
@@ -8746,8 +8751,9 @@ Overlays (Todo: clean up)
   position: relative;
   font-size: 0.75em;
   top: 15px;
+  width: 100px;
 }
-/* line 558, ../sass/_overlays.scss */
+/* line 550, ../sass/_overlays.scss */
 .wizard .bottom .nav:hover {
   -webkit-transition: background 0ms ease-out;
   -moz-transition: background 0ms ease-out;
@@ -8755,14 +8761,14 @@ Overlays (Todo: clean up)
   -o-transition: background 0ms ease-out;
   transition: background 0ms ease-out;
 }
-/* line 561, ../sass/_overlays.scss */
+/* line 553, ../sass/_overlays.scss */
 .wizard .bottom .nav span {
   display: inline-block;
   height: 30px;
   line-height: 30px;
   float: left;
 }
-/* line 566, ../sass/_overlays.scss */
+/* line 558, ../sass/_overlays.scss */
 .wizard .bottom .nav span:hover {
   -webkit-transition: background 0ms linear;
   -moz-transition: background 0ms linear;
@@ -8770,47 +8776,49 @@ Overlays (Todo: clean up)
   -o-transition: background 0ms linear;
   transition: background 0ms linear;
 }
-/* line 571, ../sass/_overlays.scss */
+/* line 563, ../sass/_overlays.scss */
 .wizard .bottom .prev {
   float: left;
   height: 30px;
   padding-left: 19px;
   background: url("../images/nav-edge-lt.png") no-repeat left top;
 }
-/* line 576, ../sass/_overlays.scss */
+/* line 568, ../sass/_overlays.scss */
 .wizard .bottom .prev span {
   padding-right: 10px;
   background: url("../images/nav-lt.png") no-repeat right top;
 }
-/* line 580, ../sass/_overlays.scss */
+/* line 572, ../sass/_overlays.scss */
 .wizard .bottom .prev:hover {
   background-position: left bottom;
 }
-/* line 582, ../sass/_overlays.scss */
+/* line 574, ../sass/_overlays.scss */
 .wizard .bottom .prev:hover span {
   background-position: right bottom;
 }
-/* line 587, ../sass/_overlays.scss */
+/* line 579, ../sass/_overlays.scss */
 .wizard .bottom .next {
   float: right;
   height: 30px;
   padding-right: 19px;
   background: url("../images/nav-edge-rt.png") no-repeat right top;
 }
-/* line 592, ../sass/_overlays.scss */
+/* line 584, ../sass/_overlays.scss */
 .wizard .bottom .next span {
   padding-left: 10px;
   background: url("../images/nav-rt.png") no-repeat left top;
+  float: right;
 }
-/* line 596, ../sass/_overlays.scss */
+/* line 589, ../sass/_overlays.scss */
 .wizard .bottom .next:hover {
   background-position: right bottom;
 }
-/* line 598, ../sass/_overlays.scss */
+/* line 591, ../sass/_overlays.scss */
 .wizard .bottom .next:hover span {
   background-position: left bottom;
+  float: right;
 }
-/* line 603, ../sass/_overlays.scss */
+/* line 597, ../sass/_overlays.scss */
 .wizard .bottom .nums {
   text-align: center;
   list-style: none outside none;
@@ -8819,7 +8827,7 @@ Overlays (Todo: clean up)
   line-height: 60px;
   font-size: 0.75em;
 }
-/* line 610, ../sass/_overlays.scss */
+/* line 604, ../sass/_overlays.scss */
 .wizard .bottom .nums li {
   list-style: none outside none;
   display: inline-block;
@@ -8830,24 +8838,24 @@ Overlays (Todo: clean up)
   line-height: 21px;
   margin: 0 3px;
 }
-/* line 619, ../sass/_overlays.scss */
+/* line 613, ../sass/_overlays.scss */
 .wizard .bottom .nums li a {
   color: #919194;
   display: block;
 }
-/* line 622, ../sass/_overlays.scss */
+/* line 616, ../sass/_overlays.scss */
 .wizard .bottom .nums li a:hover {
   cursor: default;
 }
-/* line 626, ../sass/_overlays.scss */
+/* line 620, ../sass/_overlays.scss */
 .wizard .bottom .nums li.current {
   border-color: white;
 }
-/* line 628, ../sass/_overlays.scss */
+/* line 622, ../sass/_overlays.scss */
 .wizard .bottom .nums li.current a {
   color: white;
 }
-/* line 633, ../sass/_overlays.scss */
+/* line 627, ../sass/_overlays.scss */
 .wizard .bottom .nums li.current {
   font-size: 1em;
   width: 30px;
@@ -8855,13 +8863,13 @@ Overlays (Todo: clean up)
   line-height: 27px;
 }
 
-/* line 644, ../sass/_overlays.scss */
+/* line 638, ../sass/_overlays.scss */
 .wizard-content {
   overflow: hidden;
   width: 100%;
 }
 
-/* line 649, ../sass/_overlays.scss */
+/* line 643, ../sass/_overlays.scss */
 .vm-wizard-carousel {
   width: 90000px;
   position: relative;