commit 4abc7b2981acb53a7b623031de6e8cb4b6ef4d30
Author: Sofia Papagiannaki <papagian@gmail.com>
Date:   Tue Mar 13 17:05:30 2012 +0200

    change email templates

diff --git a/snf-astakos-app/astakos/im/templates/registration/password_email.txt b/snf-astakos-app/astakos/im/templates/registration/password_email.txt
index 7d63feb..2fa00f4 100644
--- a/snf-astakos-app/astakos/im/templates/registration/password_email.txt
+++ b/snf-astakos-app/astakos/im/templates/registration/password_email.txt
@@ -1,30 +1,18 @@
 --- A translation in English follows ---
-Για να ανανεώσετε τον κωδικό πρόσβασης σας
-για την υπηρεσία {{ site_name }} της ΕΔΕΤ κατά την Alpha (πιλοτική) φάση λειτουργίας της,
-χρησιμοποιήστε τον παρακάτω σύνδεσμο:
-
-{{url}}
+Για να ανανεώσετε τον κωδικό πρόσβασης σας για την υπηρεσία {{ site_name }} της ΕΔΕΤ κατά την alpha2 (δεύτερη δοκιμαστική) φάση λειτουργίας της,
+χρησιμοποιήστε τον σύνδεσμο: {{url}}
 
 Σημείωση:
 
-Η υπηρεσία θα είναι για μερικές εβδομάδες σε φάση λειτουργίας Alpha. Αν
-και έχουμε κάνει ό,τι είναι δυνατό για να εξασφαλίσουμε την ποιότητα της
-υπηρεσίας, δεν αποκλείεται να εμφανιστούν προβλήματα στο λογισμικό
-διαχείρισης ή η υπηρεσία να μην είναι διαθέσιμη κατά διαστήματα. Για
-αυτό το λόγο, σας παρακαλούμε να μη μεταφέρετε ακόμη σημαντικά αρχεία
-στην υπηρεσία {{ site_name }}. Επίσης, παρακαλούμε να έχετε
-υπόψη σας ότι όλα τα δεδομένα, θα διαγραφούν κατά τη μετάβαση από την
-έκδοση Alpha στην έκδοση Beta. Θα υπάρξει έγκαιρη ειδοποίησή σας πριν
-από τη μετάβαση αυτή.
+Ο {{ site_name }} είναι η υπηρεσία cloud του ΕΔΕΤ. Περιλαμβάνει τον pithos+, μέσω του οποίου έχετε 50GB αποθηκευτικό χώρο για τα αρχεία σας στο cloud, και τις cyclades, που παρέχουν εικονικές μηχανές (VMs) με διάφορα λειτουργικά συστήματα (OS images).
 
-Περισσότερα για την υπηρεσία θα βρείτε στο {{ baseurl }}, αφού
-ενεργοποιήσετε την πρόσκλησή σας.
+O {{ site_name }} θα είναι για τις επόμενες λίγες εβδομάδες στη φάση λειτουργίας alpha2. Για τους νέους χρήστες, αρχικά, μέσα από το ενοποιημένο web περιβάλλον θα προσφέρεται ο pithos+ και σε λίγες μέρες (10 περίπου), μόλις ολοκληρωθεί η διαδικασία μετάβασης των χρηστών, και οι cyclades (εικονικές μηχανές). Όσοι χρήστες συμμετείχατε ήδη στην alpha1, θα εξακολουθείτε να βλέπετε, για τις επόμενες 10 ημέρες, τις εικονικές σας μηχανές μέσα απο το https://okeanos.grnet.gr και κατόπιν, με τον ίδιο σύνδεσμο, μέσα απο το ενοποιημένο περιβάλλον. Δε χρειάζεται να κάνετε τίποτε, εφόσον έχετε δηλώσει την ίδια διεύθυνση e-mail που είχατε και στην alpha1. H μετάβαση θα γίνει αυτόματα, μετά απο 10 ημέρες.
 
-Για όποιες παρατηρήσεις ή προβλήματα στη λειτουργεία της υπηρεσίας μπορείτε να
+Αν και έχουμε κάνει ό,τι είναι δυνατό για να εξασφαλίσουμε την ποιότητα της υπηρεσίας, δεν αποκλείεται να εμφανιστούν προβλήματα στο λογισμικό διαχείρισης ή η υπηρεσία να μην είναι διαθέσιμη κατά διαστήματα. Για αυτό το λόγο, σας παρακαλούμε να μη μεταφέρετε ακόμη σημαντικά αρχεία στον pithos+ ή στις εικονικές μηχανές των cyclades.
 
-Αναμένουμε τα σχόλια και τις παρατηρήσεις σας, για να βελτιώσουμε τη
-λειτουργικότητα και την αξιοπιστία της καινοτομικής αυτής υπηρεσίας.
+Αναμένουμε τα σχόλια και τις παρατηρήσεις σας, για να βελτιώσουμε τη λειτουργικότητα και την αξιοπιστία της καινοτομικής αυτής υπηρεσίας.
 
+Για όποιες παρατηρήσεις ή προβλήματα στη λειτουργία της υπηρεσίας μπορείτε να απευθύνεστε στο {{ support }}.
 
 Σας ευχαριστούμε πολύ για τη συμμετοχή στην Alpha λειτουργία του {{ site_name }}.
 
@@ -34,31 +22,24 @@
 
 --
 
-You can use the following link:
-
-{{ url }}
+You can use the  link: {{ url }}
 
 to reset your password for GRNET's {{ site_name }} service has been created
-for its Alpha test phase.
+for its alpha2 testing phase.
 
-To activate the account, please use the following link:
+Please note:
 
+{{ site_name }} is GRNET's cloud service. It includes pithos+, which offers 50GB of storage space for your files in the cloud and, cyclades, that offer virtual machines (VMs) with various operating systems (OS images).
 
-Please note:
+{{ site_name }} will be, for the next few weeks, in its alpha2 testing phase. New users, will initially have access only to pithos+, and later, after the migration phase from alpha1 to alpha2 is completed (10 days), will have access to cyclades (VMs) as well. Old users, that participated during the alpha1 phase, will continue to have access to their existing VMs, through the https://okeanos.grnet.gr, for the next 10 days, and then, through the same link, using the new web interface. There is no need to do anything, as long as your e-mail address is the same as in alpha1 phase. Migration will take place automatically, after 10 days.
 
-This service is, for a few weeks, in Alpha. Although every care has been
-taken to ensure high quality, it is possible there may still be software
-bugs, or periods of limited service availability. For this reason we kindly
-request you not to transfer important files to {{ site_name}} yet.
-Also, please bear in mind that all data will be deleted when the service moves to Beta.
-We will notify you before the transition.
+This service will remain, for a few weeks, in alpha2. Although every care has been taken to ensure high quality, it is possible there may still be software bugs, or periods of limited service availability. For this reason we kindly request you not to transfer important files to pithos+ or to the virtual machines of cyclades.
 
-For more information, please visit {{ baseurl }}, after
-activating your invitation.
+We look forward to your feedback, to improve the functionality and reliability of this innovative service.
 
-We look forward to your feedback, to improve the functionality and
-reliability of this innovative service.
+For any remarks or problems you may contact {{ support }}.
 
-Thank you for participating in the Alpha test of {{ site_name }}.
+Thank you for participating in the alpha2 test of {{ site_name }}.
 
 Greek Research and Technonogy Network - GRNET
+